import { FileUtil } from "@v-act/vjs.framework.extension.platform.services.native.mobile.fileoperation";
import { FileTransfer as FileTransfer$1 } from "@v-act/vjs.framework.extension.platform.services.native.mobile.filetransfer";
import { DialogUtil } from "@v-act/vjs.framework.extension.platform.services.view.widget.common.dialog";
import { ProgressBarUtil } from "@v-act/vjs.framework.extension.ui.common.plugin.services.progressbar";
import { $ } from "@v-act/vjs.framework.extension.vendor.jquery";
let flag = false;
let count = 1;
function initModule(sb) {
  FileTransfer$1.putInstance(exports);
}
if (window.VJSBridge) {
  window.VJSBridge.plugins.vplatform.FileTransfer = new FileTransfer();
}
const filetransferUpload = function(fileUrl, callback) {
  const url = GlobalVariables.getServerUrl();
  let serverPath = `${url}/module-operation!executeOperation?operation=FileUpload`;
  let resultFileIDs = [];
  let fileInfos = [];
  let result = {};
  let win = function(r) {
    count++;
    if (fileUrl.length == 1) {
      if (flag) {
        ProgressBarUtil.hideProgress();
      }
      if (isFunction(callback)) {
        let obj = $.parseJSON(r.response);
        fileInfos.push(obj);
        if (resultFileIDs.length == fileUrl.length - 1) {
          if (obj.data && Array.isArray(obj.data)) {
            resultFileIDs.push(obj.data[0].id);
          } else {
            resultFileIDs.push(obj.id);
          }
          result.success = true;
          result.fileIds = resultFileIDs;
          callback(resultFileIDs, fileInfos);
        } else {
          if (obj.data && Array.isArray(obj.data)) {
            resultFileIDs.push(obj.data[0].id);
          } else {
            resultFileIDs.push(obj.id);
          }
        }
      }
    } else {
      ProgressBarUtil.showProgress("\u6B63\u5728\u4E0A\u4F20" + count + "/" + fileUrl.length);
      if (isFunction(callback)) {
        let obj = $.parseJSON(r.response);
        fileInfos.push(obj);
        if (resultFileIDs.length == fileUrl.length - 1) {
          if (flag) {
            ProgressBarUtil.hideProgress();
          }
          if (obj.data && Array.isArray(obj.data)) {
            resultFileIDs.push(obj.data[0].id);
          } else {
            resultFileIDs.push(obj.id);
          }
          result.success = true;
          result.fileIds = resultFileIDs;
          callback(resultFileIDs, fileInfos);
        } else {
          if (obj.data && Array.isArray(obj.data)) {
            resultFileIDs.push(obj.data[0].id);
          } else {
            resultFileIDs.push(obj.id);
          }
        }
      }
    }
  };
  let isPrompted = false;
  let fail = function(error) {
    if (flag) {
      ProgressBarUtil.hideProgress();
    }
    if (isFunction(callback)) {
      console.log(JSON.stringify(error));
      if (isPrompted == false) {
        if (error.code == 1) {
          DialogUtil.propmtDialog("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25,\u4E0D\u5408\u6CD5\u7684URL\uFF01", null, false, void 0);
        } else if (error.code == 3) {
          DialogUtil.propmtDialog("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25,\u670D\u52A1\u5668\u6216\u7F51\u7EDC\u5F02\u5E38\uFF0C\u8BF7\u7A0D\u540E\u518D\u8BD5\uFF01", null, false, void 0);
        } else {
          DialogUtil.propmtDialog("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25,\u8BF7\u7A0D\u540E\u518D\u8BD5\uFF01", null, false, void 0);
        }
        isPrompted = true;
        result.success = false;
        result.errorCode = error.code;
        callback(result);
        return;
      }
    }
  };
  count = 1;
  for (let i = 0; i < fileUrl.length; i++) {
    if (fileUrl.length == 1) {
      ProgressBarUtil.showProgress("\u6B63\u5728\u4E0A\u4F20...");
    } else {
      if (i == 1) {
        ProgressBarUtil.showProgress("\u6B63\u5728\u4E0A\u4F20 1/" + fileUrl.length);
      }
    }
    if (i == fileUrl.length - 1) {
      flag = true;
    }
    let localFilePath = fileUrl[i];
    let options = new FileUploadOptions();
    options.fileKey = localFilePath;
    options.fileName = localFilePath.substr(localFilePath.lastIndexOf("/") + 1);
    let ft = new FileTransfer();
    ft.upload(localFilePath, encodeURI(serverPath), win, fail, options);
  }
};
const filetransferDownload = function(fileID, fileName, success, error, onProgress) {
  if (!fileName) {
    DialogUtil.propmtDialog("\u6587\u4EF6\u4E0B\u8F7D\u5931\u8D25\uFF01\u6587\u4EF6\u540D\u4E0D\u5B58\u5728\uFF0C\u8BF7\u68C0\u67E5\u6587\u4EF6\u540D\u662F\u5426\u6B63\u786E\uFF01", null, false, void 0);
  }
  let fileTransfer = new FileTransfer();
  fileTransfer.onprogress = onProgress;
  let serverPath = "module-operation!executeOperation?operation=FileDown&token=%7B%22data%22%3A%7B%22dataId%22%3A%22" + fileID + "%22%7D%7D";
  let fileURL;
  if (window.GlobalVariables) {
    let host = GlobalVariables.getServerPath() + "/";
    serverPath = host + serverPath;
    let uri = encodeURI(serverPath);
    if (cordova.platformId == "android") {
      fileURL = cordova.file.externalRootDirectory + "path/to/downloads/" + fileID + fileName.substring(fileName.lastIndexOf("."), fileName.length);
    } else {
      fileURL = "cdvfile://localhost/persistent/path/to/downloads/" + fileID + fileName.substring(fileName.lastIndexOf("."), fileName.length);
    }
    fileTransfer.download(uri, fileURL, function(entry) {
      if (isFunction(success)) {
        FileUtil.setLocalFlag(fileID);
        success(entry.toURL());
      }
    }, function(errorObJ) {
      if (isFunction(error)) {
        error({
          errorSource: errorObJ.source,
          errorTarget: errorObJ.target,
          errorCode: errorObJ.code
        });
      }
    }, false, {
      headers: {
        Authorization: "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
      }
    });
  } else {
    DialogUtil.propmtDialog("\u76EE\u524D\u6682\u4E0D\u652F\u6301PC\u7AEF\u8BBF\u95EE\u4E0B\u8F7D\uFF01", null, false, void 0);
  }
};
const supportOnProgress = window.VJSBridge ? window.VJSBridge.plugins.vplatform.FileTransfer.supportOnProgress : null;
function isFunction(arg) {
  if (typeof arg == "function") {
    return true;
  }
  return false;
}
var FileTransferCordova = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  [Symbol.toStringTag]: "Module",
  initModule,
  filetransferDownload,
  filetransferUpload,
  supportOnProgress
});
export { FileTransferCordova as FileTransfer };
